#!/usr/local/bin/perl
# July 2, 1997
# written by D. Barnes and Rob Casey
# interface for SPYDER/FARM data retrieval - Window 2 - Middle
# using cgi-lib.pl
#
# modified by John Castle, Sep 98 to add selection of output product type,
# the first of which was SAC ASCII with various bundling options
#
# modified by Robert Casey, Aug 99 to add selection of SAC binary output
#

$|=1;

push(@INC, "/www/apache/apache_1.3.4/cgi-bin/"); 
require("/www/apache/apache_1.3.4/cgi-bin/cgi-lib.pl");

&ReadParse(*param);

print &PrintHeader;
print "<HTML><HEAD>\n";
print "<BASE>\n";
print "<SCRIPT LANGUAGE = \"JavaScript\">\n";
print "<!--\n";
print "function makeRemote() {\n";
print qq|remote = window.open("","Remote","width=238,height=250");\n|;
print "remote.location.href = \"/Format2.html\";\n";
print "remote.focus();\n";
print "if (remote.opener == null) remote.opener = window;\n";
print "remote.opener.name = \"opener\";\n";
print "}\n";
print "// -->\n";
print "</SCRIPT>\n";
print "</HEAD>\n";
print "<BODY BGCOLOR=\"ffffff\">\n";

# print banner at top
print "<img src=\"/wilber_dir/Stripe_2.gif\" hspace=6 align=left>\n";
#JCC
#print "<font color = green> <blink>WILBER ISUNDER CONSTRUCTION Sept. 10 13:20PDT for ~30 min<BR></blink></font>\n";
print "Browse seismograms and/or make a data request. View the\n";
print "<A HREF=\"/wilber_dir/wilber.help.html#2\" target=\"2bottom\">help</a>\n";
print "page for instuctions on how to request data. <p>For more information\n";
print "about stations, view the <a href=\"/FDSN/FDSNstation.htm\"\n";
print "target=\"_blank\">FDSN Station Book</a>.\n";
print "<br>\n";
print "<hr>\n";

#@event_arr = split(/\//,$param{'file_path'});
#$event_time = $event_arr[scalar(@event_arr)-1];

$event_date = $param{'ev_date'};
$event_time = $param{'ev_time'};
$event_source = $param{'ev_source'};
if ($event_source eq "SPYDER") {
  $event_source = "SPYDER&reg";
}
$core_pid = $param{'core_pid'};

print "<TABLE BORDER=0 WIDTH=95%><TR><TD ALIGN=LEFT>\n";
print "<strong>\n";
print "Event:<font color=cc0000> ${event_date} ${event_time}</font> -- Source: <font color=cc0000>${event_source}</font><br>\n";

# get appropriate event file
if (${core_pid} >= 100000) {
  open (LISTFILE,"/www/HTML/wilber_dir/current_wilber_event.txt");
} else {
  open (LISTFILE,"/www/HTML/wilber_dir/events_dir/$param{text_file}");
}
while (<LISTFILE>) {
  @ev = split(/\s/);
  if ($ev[0] eq $event_date && $ev[1] eq $event_time && $ev[8] eq $param{'ev_source'})  {
    last; 
  }
}
close (LISTFILE);

$desc = $ev[7];
$desc =~ tr/_/ /;
$mag = sprintf("%3.1f",$ev[5]);
$lat = sprintf("%6.2f",$ev[3]);
$lon = sprintf("%7.2f",$ev[4]);

print "Description: <font color=cc0000>${desc}</font><br>\n";
print "Mag: <font color=cc0000>${mag}</font> -- Lat: <font color=cc0000>${lat}</font> -- Lon: <font color=cc0000>${lon}</font>\n";
print "</strong>";

if ($param{'sortmode'} eq "ALPHA") {
  $sortmode = "DIST";
  $message = "SORT STATIONS BY DISTANCE";
} else {
  $sortmode = "ALPHA";
  $message = "SORT STATIONS ALPHANUMERICALLY";
}

# hook on tool links for page refresh
print "</TD><TD ALIGN=RIGHT><a TARGET=\"2bottom\" href=\"/cgi-bin/wilber2bottom.pl?core_pid=$param{'core_pid'}&ev_date=$param{'ev_date'}&ev_time=$param{'ev_time'}&ev_source=$param{'ev_source'}&user_name=$param{'user_name'}&text_file=$param{'text_file'}\">REDISPLAY MAP PAGE</a><BR>\n";
print "<a target=2middle href=\"/cgi-bin/wilber2middle.pl?sortmode=${sortmode}&core_pid=$param{'core_pid'}&ev_date=$param{'ev_date'}&ev_time=$param{'ev_time'}&ev_source=$param{'ev_source'}&user_name=$param{'user_name'}&text_file=$param{'text_file'}\">${message}</a>";
print "</TD></TR></TABLE>";

#print "<FORM ACTION=\"/cgi-bin/nph-wilber_request.pl\" METHOD=\"POST\">\n";
print "<FORM ACTION=\"/cgi-bin/wilber_request.pl\" METHOD=\"POST\">\n";

$file_path = $ev[10];
$file_path =~ s/\.seed/.contents/g;

$contents_file = "/wave/ftp/pub/farm/${file_path}";

if (-e "${contents_file}") {
  open (CONTENTSFILE,"${contents_file}");

# get stations and channels
  $transcribe = 0;
  @channels = ('ALL');
  while (<CONTENTSFILE>) {
    $content_line = $_;
    if (($content_line !~ /[0-9]/ || $content_line =~ /^#/) && $transcribe == 1) {last;}
    if ($transcribe == 1) {
      # trim out leading spaces and then split
      ($discard,$content_line) = ($content_line =~ /^(\s*)(.*)/);
      @content = split(/\s+/,$content_line);
      for ($i=0;$i<scalar(@content);$i++) {
        if ($content[$i] ne "B074F03-16") {
          $station = $content[$i];
          if (length($content[$i+3]) > 2) { # test for location code
            $chan = $content[$i+1];         # location code not present
            $network = $content[$i+2];
          } else {
            $chan = $content[$i+2];         # location code is present
            $network = $content[$i+3];
          }
          $staflag = 1;
          $chanflag = 1;
          foreach $st (@station_names) {
            if ($st eq "${station}.${network}") {$staflag = 0;}
          }
          foreach $ch (@channels) {
            if ($ch eq $chan) {$chanflag = 0;}
          }
          last;
        }
      }
      if ($staflag) {push(@station_names,"${station}.${network}");}
      if ($chanflag) {push(@channels,${chan});}
    }
    if ($content_line =~ /Loc Chn Net Start date and time/) {$transcribe = 1;}
  }
  close (CONTENTSFILE);

# set up distance/azimuth internal table for stations
## do this one of two ways:
### if a <event>.stations file exists, then use this file for the lat/lon
### values, OR
### pull the lat/lon's from the SEED file using seedsniff (SLOWER)
#
  $stat_path = $ev[10];
  $stat_path =~ s/\.seed/.stations/g;

  if (-e "/wave/ftp/pub/farm/${stat_path}") {$stat_file_flag = 1;} else {$stat_file_flag = 0;}
  if ($stat_file_flag) {
    open (PIPE,"cat /wave/ftp/pub/farm/${stat_path} |");
  } else {
    open (PIPE,"/usr/local/bin/seedsniff 4096 4096 1 < /wave/ftp/pub/farm/$ev[10] |");
  }
  while (<PIPE>) {
    $seedsniff = $_;
    if ($stat_file_flag) {
      @seedsniff = split(/\s+/,$seedsniff);
      @lat_lon = ($seedsniff[0],$seedsniff[2],$seedsniff[3]);
    } else {
      if ($seedsniff !~ /type 050/) {next};
      @seedsniff = split(/:/,$seedsniff);
      @lat_lon = ((substr($seedsniff[1],1,5)),(substr($seedsniff[1],6,10)),(substr($seedsniff[1],16,11)));
      $lat_lon[0] =~ s/\s//g;  # remove excess spaces from station name
    }
    open (DELAZ,"/www/HTML/wilber_dir/bin/get_delaz ${lat} ${lon} $lat_lon[1] $lat_lon[2] |");
    $del_az_baz = <DELAZ>;
    close (DELAZ);
    @del_az_baz = split(/\s+/,$del_az_baz);
    $distance{$lat_lon[0]} = $del_az_baz[0];
    $azimuth{$lat_lon[0]} = $del_az_baz[1];
  }
  close (PIPE);

  # select stations
  print "<font color=blue>Click station links to browse seismograms and/or select stations for inclusion in your data request.</font><br>\n";
  print "<TABLE>\n";
  print "<TR>\n";
  $stat_row = 0;

  if ($param{'sortmode'} eq "DIST") {
    sub distsort {
      @aa = split (/\./,$a);
      @bb = split (/\./,$b);
      $distance{$aa[0]} <=> $distance{$bb[0]};
    }
    @sorted_stations = sort distsort @station_names;
  } else {
    @sorted_stations = sort @station_names;
  }
  @station_names = ('ALL');
  push @station_names,@sorted_stations;
  $max_per = int(scalar(@station_names) / 7) + 1;
  foreach $station (@station_names) {
    if ($stat_row >= $max_per) {$stat_row = 0;}
    if ($stat_row == 0) {print "<TD VALIGN=\"TOP\">\n";} # start new column
    if ($station eq "ALL") {
      print "<INPUT TYPE=checkbox NAME=station VALUE=${station}><font color=red>ALL</font><BR>\n";
      print "<font size=-1>(<font color=green>distance</font>/<font color=red>azimuth</font>)</font><BR>\n";
    } else {
      print "<INPUT TYPE=checkbox NAME=station VALUE=${station}><a TARGET=\"2bottom\" href=\"/cgi-bin/wilber_gen_sac.pl?ev_source=$param{'ev_source'}&file_path=${contents_file}&station=${station}\">${station}</a><BR>\n";
      @sta = split(/\./,$station);
      $dist = sprintf("%d",int($distance{$sta[0]}));
      $azim = sprintf("%d",int($azimuth{$sta[0]}));
      print "<font size=-1>(<font color=green>${dist}&deg</font>/<font color=red>${azim}&deg</font>)</font><BR>\n";
    }
    $stat_row++;
  }
  print "</TABLE><BR>\n";

  # channel selections
  print "<font color=blue>Check off desired channels for inclusion in your data request.</font> (<i>wildcards select only seismic channels</i>)<br>\n";
  print "<TABLE>\n";
  print "<TR>\n";
  $prev_chan = "Z";
  $chan_col = 0;
  @sortedchans = sort(@channels);
  foreach $chan (@sortedchans) {
    $chan_prefix = substr($chan,0,1);
    $prev_chan_prefix = substr($prev_chan,0,1);
    if ($chan_prefix ne $prev_chan_prefix) {
      $chan_col = 0;
    }
    if ($chan_col == 0) {  # print channel group checkbox
      # check to see if there are any non-seismic channels for a separate row
      if (scalar(@non_seis) > 0) {
        print "<TR>\n<TD></TD>";  # return with indent
        foreach $non_seis (@non_seis) {
          print "<TD VALIGN=\"TOP\">\n<INPUT TYPE=checkbox NAME=channel VALUE=${non_seis}><font color=blue>${non_seis}</font>\n";
        }
      }
      # make row for new frequency set
      if ($chan ne "ALL") {
        # generate seismic channel set for this frequency
        $freq_set = "";
        foreach $c (@sortedchans) {   # weed out the non_seismic channels
          if ($c =~ /${chan_prefix}[HLG]./) {
            if ("$freq_set" eq "") {
              $freq_set = $c;
            } else {
              $freq_set = "$freq_set,$c";
            }
          }
        }
        if ("$freq_set" eq "") {
          print "<TD></TD>\n"; # don't print wildcard without seismic channels
        } else {
          print "<TR>\n";
          print "<TD VALIGN=\"TOP\">\n<INPUT TYPE=checkbox NAME=channel VALUE=\"${freq_set}\"><font color=green>${chan_prefix}\?\?\n</font>";
        }
      } else {
        print "<TR>\n";
      }
      @non_seis = ();  # list of non-seismic channels
    }
    if ($chan eq "ALL") {
      print "<TD VALIGN=\"TOP\">\n<INPUT TYPE=checkbox NAME=channel VALUE=${chan}><font color=red>${chan}</font>\n";
      # generate the E,N, and Z orientation wildcards
      foreach $orientation ('E','N','Z') {
        $or_set = "";
        foreach $c (@sortedchans) {   # weed out the non_seismic channels
          if ($c =~ /[BESHMLVU][HLG]${orientation}/) {
            if ("$or_set" eq "") {
              $or_set = $c;
            } else {
              $or_set = "$or_set,$c";
            }
          }
        }
        if ("$or_set" ne "") {
          print "<TD VALIGN=\"TOP\">\n<INPUT TYPE=checkbox NAME=channel VALUE=\"${or_set}\"><font color=brown>\?\?${orientation}\n</font>";
        }
      }
    } else {
      if ($chan =~ /[BESHMLVU][HLG]./) {  # check for non_seismic channels
        print "<TD VALIGN=\"TOP\">\n<INPUT TYPE=checkbox NAME=channel VALUE=${chan}><font color=blue>${chan}</font>\n";
      } else {
        push @non_seis, $chan; # non-seismic channels will be on a separate row 
      }
    }
    $chan_col++;
    $prev_chan = $chan;
  }
  print "</TABLE><BR>\n";

  #JCC editing
print "Select data format: <SELECT NAME=data_format>\n";
print "<OPTION SELECTED VALUE=\"seed\">SEED (default)\n";
print "<OPTION VALUE=\"SAC.ind\">SAC ASCII individual files\n";
print "<OPTION VALUE=\"SAC.tar\">SAC ASCII tar file\n";
print "<OPTION VALUE=\"SAC.tar.gz\">SAC ASCII gzipped tar file\n";
print "<OPTION VALUE=\"SAC.tar.Z\">SAC ASCII compressed tar file\n";
print "<OPTION VALUE=\"bin.SAC.ind\">SAC BINARY individual files\n";
print "<OPTION VALUE=\"bin.SAC.tar\">SAC BINARY tar file\n";
print "<OPTION VALUE=\"bin.SAC.tar.gz\">SAC BINARY gzipped tar file\n";
print "<OPTION VALUE=\"bin.SAC.tar.Z\">SAC BINARY compressed tar file\n";
print "</SELECT>\n";
#end JCC editing

  # temporary construction notice
  #print "<img src=/gifs/at-work.gif>\n";
  #print "<BR>CURRENTLY UNDER CONSTRUCTION...<i>thanks for your patience</i><p>\n";

  # request submit controls
  #print "<font color=blue>Once you have checked off both <b>channel</b> and <b>station</b> boxes, set your time window parameters and click REQUEST DATA to begin processing.</font><p>";
  print "<TABLE border=0 width=80%><TR>\n";
  print "<TD>\n";
  print "<font color=blue>Time window data:</font>\n";
  print "</TD><TD><font color=blue>Click button to process request:</font>\n";
  print "</TD></TR><TR><TD>\n";
  print "<SELECT NAME=before size=1>\n";
  for ($i=0;$i<=20;$i++) {
    if ($i == 1) {
      print "<OPTION SELECTED>$i ";
    } else {
      print "<OPTION>$i ";
    }
  }
  print "\n</SELECT>\nminutes before P and<br>\n";

  print "<SELECT NAME=after size=1>\n";
  for ($i=0;$i<=60;$i++) {
    if ($i == 10) {
      print "<OPTION SELECTED>$i ";
    } else {
      print "<OPTION>$i ";
    }
  }
  print "\n</SELECT>\nminutes after P<p>\n";
  print "</TD><TD valign=top>\n";

  #print "<font color=blue>Click here to submit your request</font><br>\n";
  print "<INPUT TYPE=hidden NAME=core_pid VALUE=\"$core_pid\">\n";
  print "<INPUT TYPE=hidden NAME=ev_date VALUE=\"$event_date\">\n";
  print "<INPUT TYPE=hidden NAME=ev_time VALUE=\"$event_time\">\n";
  print "<INPUT TYPE=hidden NAME=ev_source VALUE=\"$param{'ev_source'}\">\n";
  print "<INPUT TYPE=hidden NAME=seed_path VALUE=\"$ev[10]\">\n";
  print "<INPUT TYPE=hidden NAME=user_name VALUE=\"$param{'user_name'}\">\n";
  print "<INPUT TYPE=hidden NAME=ev_lat VALUE=\"$lat\">\n";
  print "<INPUT TYPE=hidden NAME=ev_lon VALUE=\"$lon\">\n";
  print "<INPUT TYPE=submit NAME=wilbreq VALUE=\"REQUEST DATA\">\n";
}
print "</TD></TR></TABLE>\n";
print "</FORM></BODY>\n";
print "</HTML>\n";

exit (0);

